;------------------------------------------------------------;
; The author, Philippe Coulombe, has given permission to use ;
; this module to the users of The GeneSys Development System ;
; and is for educational use only. Users are not allowed to  ;
; use this module in commercial software. To use this module ;
; for any for profit purpose, the author must be contacted.  ;
; Send your request directly to Philippe, ebmoluocp@yahoo.ca ;
;------------------------------------------------------------;
; When lpszStr1 and lpszStr2 are equal (case sensitive), the ;
; returned value is the character count of both strings      ;
; excluding the null-terminated character.                   ;
;------------------------------------------------------------;

.586

.MODEL FLAT, STDCALL

OPTION CASEMAP:NONE


.CODE

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

StrCmpW PROC p_lpszStr1:DWORD, p_lpszStr2:DWORD

   push edi

   mov edi, [esp+8]
   mov edx, [esp+12]
   xor eax, eax

   align 4
@@:
   mov cx, [edi+eax]
   cmp cx, [edx+eax]
   jne @F
   add eax, 2
   test cx, cx
   jnz @B

   sub eax, 2
   shr eax, 1

   pop edi
   ret 8

@@:
   xor eax, eax

   pop edi
   ret 8

StrCmpW ENDP

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

END